Index: channels/sip/dialplan_functions.c
===================================================================
--- channels/sip/dialplan_functions.c	(revision 300039)
+++ channels/sip/dialplan_functions.c	(working copy)
@@ -194,6 +194,14 @@
 				{ "stdevrtt",              DBL, { .d8 = &stats.stdevrtt, }, },
 				{ "local_ssrc",            INT, { .i4 = &stats.local_ssrc, }, },
 				{ "remote_ssrc",           INT, { .i4 = &stats.remote_ssrc, }, },
+				// Not documented, 1.6-compatible aliases for options:
+				{ "local_count",           INT, { .i4 = &stats.txcount, }, },
+				{ "remote_count",          INT, { .i4 = &stats.rxcount, }, },
+				{ "local_jitter",          DBL, { .d8 = &stats.txjitter, }, },
+				{ "remote_jitter",         DBL, { .d8 = &stats.rxjitter, }, },
+				// These two aliases look as if switched around, but they are not. New names are more consistent.
+				{ "local_lostpackets",     INT, { .i4 = &stats.rxploss, }, },
+				{ "remote_lostpackets",    INT, { .i4 = &stats.txploss, }, },
 				{ NULL, },
 			};
 
Index: funcs/func_channel.c
===================================================================
--- funcs/func_channel.c	(revision 300039)
+++ funcs/func_channel.c	(working copy)
@@ -173,29 +173,29 @@
 						<para>     <literal>text</literal>              Get data about the text stream</para>
 						<para>    Argument 2:</para>
 						<para>     <literal>local_ssrc</literal>        Local SSRC (stream ID)</para>
-						<para>     <literal>local_lostpackets</literal> Local lost packets</para>
-						<para>     <literal>local_jitter</literal>      Local calculated jitter</para>
+						<para>     <literal>remote_ssrc</literal>       Remote SSRC (stream ID)</para>
+						<para>     <literal>txcount</literal>           Number of transmitted packets</para>
+						<para>     <literal>rxcount</literal>           Number of received packets</para>
+						<para>     <literal>txjitter</literal>          Local calculated jitter</para>
 						<para>     <literal>local_maxjitter</literal>   Local calculated jitter (maximum)</para>
 						<para>     <literal>local_minjitter</literal>   Local calculated jitter (minimum)</para>
 						<para>     <literal>local_normdevjitter</literal>Local calculated jitter (normal deviation)</para>
 						<para>     <literal>local_stdevjitter</literal> Local calculated jitter (standard deviation)</para>
-						<para>     <literal>local_count</literal>       Number of received packets</para>
-						<para>     <literal>remote_ssrc</literal>       Remote SSRC (stream ID)</para>
-						<para>     <literal>remote_lostpackets</literal>Remote lost packets</para>
-						<para>     <literal>remote_jitter</literal>     Remote reported jitter</para>
+						<para>     <literal>rxjitter</literal>          Remote reported jitter</para>
 						<para>     <literal>remote_maxjitter</literal>  Remote calculated jitter (maximum)</para>
 						<para>     <literal>remote_minjitter</literal>  Remote calculated jitter (minimum)</para>
 						<para>     <literal>remote_normdevjitter</literal>Remote calculated jitter (normal deviation)</para>
 						<para>     <literal>remote_stdevjitter</literal>Remote calculated jitter (standard deviation)</para>
-						<para>     <literal>remote_count</literal>      Number of transmitted packets</para>
-						<para>     <literal>remote_ssrc</literal>       Remote SSRC (stream ID)</para>
-						<para>     <literal>remote_lostpackets</literal>Remote lost packets</para>
-						<para>     <literal>remote_jitter</literal>     Remote reported jitter</para>
-						<para>     <literal>remote_maxjitter</literal>  Remote calculated jitter (maximum)</para>
-						<para>     <literal>remote_minjitter</literal>  Remote calculated jitter (minimum)</para>
-						<para>     <literal>remote_normdevjitter</literal>Remote calculated jitter (normal deviation)</para>
-						<para>     <literal>remote_stdevjitter</literal>Remote calculated jitter (standard deviation)</para>
-						<para>     <literal>remote_count</literal>      Number of transmitted packets</para>
+						<para>     <literal>rxploss</literal>           Local calculated at receiver</para>
+						<para>     <literal>local_maxrxploss</literal>  Local calculated packet loss (maximum)</para>
+						<para>     <literal>local_minrxploss</literal>  Local calculated packet loss (minimum)</para>
+						<para>     <literal>local_normdevrxploss</literal>Local calculated packet loss (normal deviation)</para>
+						<para>     <literal>local_stdevrxploss</literal>Local calculated packet loss (standard deviation)</para>
+						<para>     <literal>txploss</literal>           Remote reported lost packets</para>
+						<para>     <literal>remote_maxrxploss</literal> Remote calculated packet loss (maximum)</para>
+						<para>     <literal>remote_minrxploss</literal> Remote calculated packet loss (minimum)</para>
+						<para>     <literal>remote_normdevrxploss</literal>Remote calculated packet loss (normal deviation)</para>
+						<para>     <literal>remote_stdevrxploss</literal>Remote calculated packet loss (standard deviation)</para>
 						<para>     <literal>rtt</literal>               Round trip time</para>
 						<para>     <literal>maxrtt</literal>            Round trip time (maximum)</para>
 						<para>     <literal>minrtt</literal>            Round trip time (minimum)</para>