Index: app_meetme.c
===================================================================
--- app_meetme.c	(revision 308619)
+++ app_meetme.c	(working copy)
@@ -222,6 +222,10 @@
 			<ref type="application">MeetMeCount</ref>
 			<ref type="application">MeetMeAdmin</ref>
 			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+			<ref type="manager">MeetmeList</ref>
 		</see-also>
 	</application>
 	<application name="MeetMeCount" language="en_US">
@@ -243,6 +247,12 @@
 		</description>
 		<see-also>
 			<ref type="application">MeetMe</ref>
+			<ref type="application">MeetMeAdmin</ref>
+			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+			<ref type="manager">MeetmeList</ref>
 		</see-also>
 	</application>
 	<application name="MeetMeAdmin" language="en_US">
@@ -340,6 +350,12 @@
 		</description>
 		<see-also>
 			<ref type="application">MeetMe</ref>
+			<ref type="application">MeetMeCount</ref>
+			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+			<ref type="manager">MeetmeList</ref>
 		</see-also>
 	</application>
 	<application name="MeetMeChannelAdmin" language="en_US">
@@ -366,6 +382,15 @@
 			<para>Run admin <replaceable>command</replaceable> for a specific
 			<replaceable>channel</replaceable> in any coference.</para>
 		</description>
+		<see-also>
+			<ref type="application">MeetMe</ref>
+			<ref type="application">MeetMeCount</ref>
+			<ref type="application">MeetMeAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+			<ref type="manager">MeetmeList</ref>
+		</see-also>
 	</application>
 	<application name="SLAStation" language="en_US">
 		<synopsis>
@@ -393,6 +418,9 @@
 				</variable>
 			</variablelist>
 		</description>
+		<see-also>
+			<ref type="application">SLATrunk</ref>
+		<see-also>
 	</application>
 	<application name="SLATrunk" language="en_US">
 		<synopsis>
@@ -427,6 +455,9 @@
 				</variable>
 			</variablelist>
 		</description>
+		<see-also>
+			<ref type="application">SLAStation</ref>
+		<see-also>
 	</application>
 	<function name="MEETME_INFO" language="en_US">
 		<synopsis>
@@ -460,6 +491,9 @@
 			<ref type="application">MeetMeCount</ref>
 			<ref type="application">MeetMeAdmin</ref>
 			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+			<ref type="manager">MeetmeList</ref>
 		</see-also>
 	</function>
 	<manager name="MeetmeMute" language="en_US">
@@ -473,6 +507,15 @@
 		</syntax>
 		<description>
 		</description>
+		<see-also>
+			<ref type="application">MeetMe</ref>
+			<ref type="application">MeetMeCount</ref>
+			<ref type="application">MeetMeAdmin</ref>
+			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+			<ref type="manager">MeetmeList</ref>
+		</see-also>
 	</manager>
 	<manager name="MeetmeUnmute" language="en_US">
 		<synopsis>
@@ -485,6 +528,15 @@
 		</syntax>
 		<description>
 		</description>
+		<see-also>
+			<ref type="application">MeetMe</ref>
+			<ref type="application">MeetMeCount</ref>
+			<ref type="application">MeetMeAdmin</ref>
+			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeList</ref>
+		</see-also>
 	</manager>
 	<manager name="MeetmeList" language="en_US">
 		<synopsis>
@@ -501,6 +553,15 @@
 			MeetmeList will follow as separate events, followed by a final event called
 			MeetmeListComplete.</para>
 		</description>
+		<see-also>
+			<ref type="application">MeetMe</ref>
+			<ref type="application">MeetMeCount</ref>
+			<ref type="application">MeetMeAdmin</ref>
+			<ref type="application">MeetMeChannelAdmin</ref>
+			<ref type="function">MEETME_INFO</ref>
+			<ref type="manager">MeetmeMute</ref>
+			<ref type="manager">MeetmeUnmute</ref>
+		</see-also>
 	</manager>
  ***/
 